%matplotlib inline
import pandas as pd
import matplotlib.pyplot as plt
from pandas.plotting import register_matplotlib_converters
from sklearn import linear_model

SERVICE_NUM = 2 # ͑Ώۂ̃t}T[rX̐
ITEM_NUM = 3 # ͑Ώۂ̏i̐
RECENT_DAYS = 5 # ߂ŕ͂

register_matplotlib_converters()

# Ot̃TCYݒ
plt.figure(figsize=(15, 18))

# `Af
clf = linear_model.LinearRegression()

# CSVǂݍ݁B1ڂ͓t^œǂݍ݁ACfbNXƂ
df= pd.read_csv('data.csv',index_col=0, parse_dates=True)

# ϐݒ
X = df.index.to_frame() # S
X_recent = X.tail(RECENT_DAYS) # 

# vbg̔ԍ
no = 1

# iƂɃJƃN}̃f[^͂ƃOt쐬
for i, (col_name, Y) in enumerate(df.iteritems()):
    # JƃN}2񂲂ƓOtɃvbg
    if i % SERVICE_NUM == 0:
        plt.subplot(ITEM_NUM, 1, no) # vbgݒ
        plt.title('item' + str(no)) # ^Cg
    else:
        no += 1 # vbg1i߂

    # S̃Ot쐬
    plt.plot(X, Y, label=col_name)

    # Sŕ
    clf.fit(X, Y) # wK
    plt.plot(X, clf.predict(X.values.astype(float)),
        linestyle='dashed', label=col_name + '_reg') # A`

    # ߂ŕ
    clf.fit(X_recent, Y.tail(RECENT_DAYS)) # wK
    label_recent = f'{col_name}_reg_recent_{RECENT_DAYS}days'
    plt.plot(X_recent, clf.predict(X_recent.values.astype(float)),
        linestyle='dotted', label=label_recent) # A`

    plt.legend() # }\

plt.show()